明经CAD社区

 找回密码
 注册

QQ登录

只需一步,快速开始

搜索
查看: 788|回复: 7

画圆弧两段源码,下载于网络

[复制链接]
发表于 2024-6-21 14:48:22 | 显示全部楼层 |阅读模式
(defun c:ale( / cen pt1 r lenth ang )
(setq cen (getpoint"\n请输入圆心"))
(setq pt1 (getpoint cen "\n请输入圆弧起点"))
(setq r (distance cen pt1))
(setq lenth(getreal "\n请输入弧长"))
(setq ang (* 180 (/ lenth r pi)))
(command "arc""c"cen pt1 "a" ang) )

两点和弧长画圆弧
(defun c:aa (/ p1 p2 s a l x xx fx flx r c c1 c2 mspace myobj)
(defun N ()
(setq c (- (+ a (* 0.5 pi)) (* x 0.5)))
(setq cen (polar p1 c r))
(setq c1 (+ c pi))
(setq c2 (+ c1 x))
(setq myobj (vla-addarc mspace (vlax-3d-point cen) r c1 c2))
(princ)
)
(setq p1 (getpoint "\n请输入圆弧第一点:"))
(setq p2 (getpoint p1 "\n请输入圆弧第二点:"))
(setq s (getdist p1 "\n请输入弧长:"))
(setq a (angle p1 p2))
(setq l (distance p1 p2))
(vl-load-com)
(setq mspace (vla-get-modelspace
(vla-get-activedocument (vlax-get-acad-object))
)
)
(if (<= s l)
(progn
(prompt "您所要画的圆弧并不存在!")
(princ)
)
(progn
(setq x 2)
(setq fx (- (/ (sin (/ x 2)) x) (/ (* 0.5 l) s)))
(setq
flx (/ (- (* 0.5 x (cos (* 0.5 x))) (sin (* 0.5 x))) (* x x))
)
(setq xx (- x (/ fx flx)))
(while (> (abs (- x xx)) 0.0000000001)
(setq x xx)
(setq fx (- (/ (sin (/ x 2)) x) (/ (* 0.5 l) s)))
(setq flx
(/ (- (* 0.5 x (cos (* 0.5 x))) (sin (* 0.5 x))) (* x x))
)
(setq xx (- x (/ fx flx)))
)
(setq r (/ s xx))
(initget "N S")
(setq aa (getkword "\n 请输入圆弧方向[逆时针(N)/顺时针(S)]:"))
(if (= aa nil)
(setq aa "N")
)
(if (= aa "N")
(N)
(if (= aa "S")
(progn
(setq c (- (+ a (/ x 2)) (* 0.5 pi)))
(setq cen (polar p1 c r))
(setq c1 (- (+ c pi) x))
(setq c2 (+ c pi))
(setq myobj (vla-addarc mspace (vlax-3d-point cen) r c1 c2))
(princ)
)
)
)
)
)
)

 楼主| 发表于 2024-6-21 14:51:11 | 显示全部楼层
望大神能帮忙写个知道半径和角度,画圆弧的源码
发表于 2024-6-21 14:53:03 | 显示全部楼层
可以去看highflybird的帖子,很全面的。代码也清晰
 楼主| 发表于 2024-6-21 15:35:39 | 显示全部楼层
自贡黄明儒 发表于 2024-6-21 14:53
可以去看highflybird的帖子,很全面的。代码也清晰

小白看不懂,不会写
发表于 2024-6-21 15:36:56 | 显示全部楼层
(ACR)圆心、半径、起始角度和终止角度画弧 http://bbs.mjtd.com/forum.php?mo ... 455&fromuid=7316343
 楼主| 发表于 2024-6-21 15:52:24 | 显示全部楼层
fangmin723 发表于 2024-6-21 15:36
(ACR)圆心、半径、起始角度和终止角度画弧 http://bbs.mjtd.com/forum.php?mo ... 455&fromuid=7316343

相对来说输入圆心,圆弧起点,和弧长,这个源码我需要手算出弧长,但是已经相当方便了
发表于 2024-6-22 09:31:56 | 显示全部楼层
感谢大佬分享,插眼关注
 楼主| 发表于 2024-11-9 09:34:46 | 显示全部楼层
czb203 发表于 2024-6-22 09:31
感谢大佬分享,插眼关注

(entmake
        (list '(0 . "ARC")
                (cons 10 (setq cen (getpoint "\n指定圆心")))
                (cons 40 (getdist cen "\n指定半径"))
                (cons 50 (setq sang (angle cen (getpoint cen "\n指定起点"))))
                (cons 51 (+ sang (* pi (/ (getreal "\n指定角度(°)") 180.0))))
        )
)
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号 )  
©2000-2023 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2024-11-25 05:38 , Processed in 0.193122 second(s), 23 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表